#include "sktheme.h"
char css_docWidget[]="\
QDockWidget {\n\
    outline: 1px solid %1;\n\
    background-color: %2;\n\
    border: 1px solid %1;\n\
    border-radius: 4px;\n\
    titlebar-close-icon: url(\"%4\");\n\
    titlebar-normal-icon: url(\"%5\");\n\
}\n\
\n\
QDockWidget::title {\n\
    border: none;\n\
    background-color: %3;\n\
}\n\
\n\
QDockWidget::close-button {\n\
    image: url(\"%4\");\n\
    border-radius: 4px;\n\
    border: none;\n\
}\n\
\n\
QDockWidget::close-button:hover {\n\
    image: url(\"%6\");\n\
                border-radius: 4px;\n\
                border: none;\n\
}\n\
\n\
QDockWidget::close-button:pressed {\n\
    image: url(\"%7\");\n\
                border-radius: 4px;\n\
                border: none;\n\
}\n\
\n\
QDockWidget::float-button {\n\
    image: url(\"%5\");\n\
    border-radius: 4px;\n\
    border: none;\n\
}\n\
\n\
QDockWidget::float-button:hover {\n\
    image: url(\"%8\");\n\
}\n\
\n\
QDockWidget::float-button:pressed {\n\
    image: url(\"%9\");\n\
}\n\
";
SKTheme * SKTheme::globalTheme=0;
SKTheme *SKTheme::getGlobalTheme()
{
    if(!globalTheme)
    {
        globalTheme=new SKTheme();
    }
    return globalTheme;
}

SKTheme::SKTheme(QObject *parent)
    : QObject(parent), m_themeId(0)
{
}

void SKTheme::switchTheme(int nt)
{
    if(m_themeId==nt)
        return;
    if(m_themeId<0)
        return;
    if(m_themeId>1)
        return;
    m_themeId=nt;
    emit widgetCSSChanged("QDockWidget");
    emit widgetCSSChanged("QMainWindow");
}

QString SKTheme::getCSSForWidget(QString wType)
{
    if(wType=="QDockWidget")
        return getCSSForDockWidget();
    if(wType=="QMainWindow")
        return getCSSForMainWindow();
    return QString();
}

QString SKTheme::getCSSForDockWidget()
{
    QString res=QString::fromLatin1(css_docWidget);
    return res.arg(getBorderColor()).arg(getDeepBackgroundColor()).arg(getSurfBackgroundColor()).
            arg(getDockCloseIconN()).arg(getDockDetachIconN()).
            arg(getDockCloseIconH()).arg(getDockCloseIconH()).
            arg(getDockDetachIconH()).arg(getDockDetachIconH());
}

QString SKTheme::getCSSForMainWindow()
{
    QString res=QString("%1").arg(getCSSForDockWidget());
    return res;
}

QString SKTheme::getDeepBackgroundColor()
{
    if(m_themeId)
        return "#262626";
    return "#808080";
}

QString SKTheme::getSurfBackgroundColor()
{
    if(m_themeId)
        return "#3F3F3F";
    return "#F2F2F2";
}

QString SKTheme::getBorderColor()
{
    if(m_themeId)
        return "#808080";
    return "#808080";
}

QString SKTheme::getForegroundColor()
{
    if(m_themeId)
        return "#808080";
    return "#000000";
}

QString SKTheme::getHighlightedForegroundColor()
{
    if(m_themeId)
        return "#FFFFFF";
    return "#000000";
}

QString SKTheme::getDockCloseIconN()
{
    if(m_themeId)
        return "://styleres/dockwidget_close_1.svg";
    return "://styleres/dockwidget_close_0.svg";
}

QString SKTheme::getDockCloseIconH()
{
    if(m_themeId)
        return "://styleres/dockwidget_close_1h.svg";
    return "://styleres/dockwidget_close_0h.svg";
}

QString SKTheme::getDockDetachIconN()
{
    if(m_themeId)
        return "://styleres/dockwidget_detach_1.svg";
    return "://styleres/dockwidget_detach_0.svg";
}

QString SKTheme::getDockDetachIconH()
{
    if(m_themeId)
        return "://styleres/dockwidget_detach_1h.svg";
    return "://styleres/dockwidget_detach_0h.svg";
}
